<script setup>
import {ref} from 'vue'
import {useTrainerStore} from "@/stores/trainer"
import {useEnumStore} from "@/stores/enumStore";

const trainerStore = useTrainerStore()
const enumStore = useEnumStore()
const trainerFirstName = ref("")
const trainerLastName = ref("")
const trainerEmail = ref("")
const trainerCity = ref("")
const trainerSalary = ref("")
const trainerEmployment = ref("")
const trainerSubject = ref([])

const apiError = ref("")

async function createTrainer() {

  apiError.value = ""

  try {
    await trainerStore.createTrainer({
      firstName: trainerFirstName.value,
      lastName: trainerLastName.value,
      email: trainerEmail.value,
      residence: trainerCity.value,
      salary: trainerSalary.value,
      employmentType: trainerEmployment.value,
      subjects: trainerSubject.value

    })

  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }

  trainerFirstName.value = ""
  trainerLastName.value = ""
  trainerEmail.value = ""
  trainerCity.value = ""
  trainerSalary.value = ""
  trainerEmployment.value = ""
  trainerSubject.value = []
}

</script>

<template>
  <div class="bg-black text-white rounded-2 p-3">
    <form @submit.prevent="createTrainer">
      <div class="mb-3 row">
        <label class="col-12 col-md-6">
          <span class="form-label">First Name</span>
          <input type="text" name="firstname" v-model="trainerFirstName" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Last Name</span>
          <input type="text" name="lastname" v-model="trainerLastName" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Email</span>
          <input type="text" name="email" v-model="trainerEmail" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">City</span>
          <input type="text" name="city" v-model="trainerCity" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Salary</span>
          <input type="number" name="salary" v-model="trainerSalary" class="form-control">
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Employment Type</span>
          <select class="form-select" name="employment" v-model="trainerEmployment">
            <option v-for="emp in enumStore.employmentTypes">{{ emp }}</option>
          </select>
        </label>
        <label class="col-12 col-md-6 mt-2">
          <span class="form-label">Subject</span>
        </label>
        <fieldset>
          <div class="form-check" v-for="subjects in enumStore.subjects">
            <input type="checkbox" class="form-check-input" v-model="trainerSubject" :value="subjects">
            <label class="form-check-label" for="check1">{{ subjects }}</label>
          </div>
        </fieldset>
      </div>
      <button type="submit" class="btn btn-warning">Add Trainer</button>
    </form>
  </div>
</template>

<style scoped>
.bg-black {
  width: 1000px;
}
</style>